package shared.model.reader.xmlobjects;

import java.util.*;

import neuroml.core.*;

import shared.model.structure.*;
import shared.model.utils.*;

public class XMLInteractionTemplate
{
        public String id;
        public String type;
        public String componentPaths;
        public String potentialTemplates;
        public String forceMults;
        public String valueMults;

        public XMLInteractionTemplate()
        {
        }

        public XMLInteractionTemplate(InteractionTemplate inter)
        {
                id = inter.getId();
                type = inter.getType();

                String[] compPaths = inter.getComponentPaths();
                componentPaths = "";
                for (int i=0; i<compPaths.length; i++)
                {
                        componentPaths += ";" + compPaths[i];
                }
                if (componentPaths.length() > 0)
                {
                        componentPaths = componentPaths.substring(1);
                }

                String[] potentTemps = inter.getPotentialTemplates();
                potentialTemplates = "";
                for (int i=0; i<potentTemps.length; i++)
                {
                        potentialTemplates += ";" + potentTemps[i];
                }
                if (potentialTemplates.length() > 0)
                {
                        potentialTemplates = potentialTemplates.substring(1);
                }

                String[] fmults = inter.getForceMults();
                forceMults = "";
                for (int i=0; i<fmults.length; i++)
                {
                        forceMults += ";" + fmults[i];
                }
                if (forceMults.length() > 0)
                {
                        forceMults = forceMults.substring(1);
                }

                String[] vmults = inter.getValueMults();
                valueMults = "";
                for (int i=0; i<vmults.length; i++)
                {
                        valueMults += ";" + vmults[i];
                }
                if (valueMults.length() > 0)
                {
                        valueMults = valueMults.substring(1);
                }
        }

        public InteractionTemplate getObject()
        {
                InteractionTemplate interactionTemplate = new InteractionTemplate(id);
                interactionTemplate.setType(type);
                interactionTemplate.setComponentPaths(Functions.split(';', componentPaths));
                interactionTemplate.setPotentialTemplates(Functions.split(';', potentialTemplates));
                interactionTemplate.setForceMults(Functions.split(';', forceMults));
                interactionTemplate.setValueMults(Functions.split(';', valueMults));

                return interactionTemplate;
        }
}

