package shared.model.reader.xmlobjects;

import java.util.*;

import neuroml.core.*;

import shared.model.structure.*;
import shared.model.utils.*;

public class XMLPotentialTemplate
{
        public String id;
        public String forces;
        public String values;

        public XMLPotentialTemplate()
        {
        }

        public XMLPotentialTemplate(PotentialTemplate potential)
        {
                id = potential.getId();

                String[] v = potential.getValues();
                values = "";
                for (int i=0; i<v.length; i++)
                {
                        values += ";" + v[i];
                }
                if (values.length() > 0)
                {
                        values = values.substring(1);
                }

                String[] f = potential.getForces();
                forces = "";
                for (int i=0; i<f.length; i++)
                {
                        forces += ";" + f[i];
                }
                if (forces.length() > 0)
                {
                        forces = forces.substring(1);
                }
                System.out.println("created");
        }

        public PotentialTemplate getObject()
        {
                PotentialTemplate potentialTemplate = new PotentialTemplate(id);
                potentialTemplate.setForces(Functions.split(';', forces));
                potentialTemplate.setValues(Functions.split(';', values));

                return potentialTemplate;
        }
}

