package shared.model.reader.xmlobjects;

import java.util.*;

import neuroml.core.*;

import shared.model.structure.*;
import shared.model.utils.*;

public class XMLStateTemplate
{
        public String id;
        public String interactionTemplateIds;
        public String conditionTemplateIds;

        public XMLStateTemplate()
        {
        }

        public XMLStateTemplate(StateTemplate state)
        {
                id = state.getId();

                String[] interTemplates = state.getInteractionTemplateIds();
                interactionTemplateIds = "";
                for (int i=0; i<interTemplates.length; i++)
                {
                        interactionTemplateIds += ";" + interTemplates[i];
                }
                if (interactionTemplateIds.length() > 0)
                {
                        interactionTemplateIds = interactionTemplateIds.substring(1);
                }

                String[] condTemplates = state.getConditionTemplateIds();
                conditionTemplateIds = "";
                for (int i=0; i<condTemplates.length; i++)
                {
                        conditionTemplateIds += ";" + condTemplates[i];
                }
                if (conditionTemplateIds.length() > 0)
                {
                        conditionTemplateIds = conditionTemplateIds.substring(1);
                }
        }

        public StateTemplate getObject()
        {
                StateTemplate stateTemplate = new StateTemplate(id);
                stateTemplate.setInteractionTemplateIds(Functions.split(';', interactionTemplateIds));
                stateTemplate.setConditionTemplateIds(Functions.split(';', conditionTemplateIds));

                return stateTemplate;
        }
}

