package shared.model.structure;

import java.util.*;

import javax.vecmath.*;

public class SimObject
{
        private String id;
        private String templateId;
        private String[] particleIds;
        private String[] subObjectIds;
        private String[] stateIds;

        private Vector3f centreOfMass;
        private AxisAngle4f orientation;

        public SimObject(String i)
        {
                id = i;
                templateId = "";
                particleIds = new String[0];
                subObjectIds = new String[0];
                stateIds = new String[0];
                orientation = new AxisAngle4f();
                centreOfMass = new Vector3f();
        }

        public void setId(String i)
        {
                id = i;
        }

        public String getId()
        {
                return id;
        }

        public void setStateIds(String[] ids)
        {
                stateIds = ids;
        }

        public String[] getStateIds()
        {
                return stateIds;
        }

        public void setSubObjectIds(String[] ids)
        {
                subObjectIds = ids;
        }

        public String[] getSubObjectIds()
        {
                return subObjectIds;
        }

        public void setParticleIds(String[] ids)
        {
                particleIds = ids;
        }

        public String[] getParticleIds()
        {
                return particleIds;
        }

        public void setTemplateId(String i)
        {
                templateId = i;
        }

        public String getTemplateId()
        {
                return templateId;
        }

        public String toString()
        {
                String s = templateId + " (SimObjectInstance)";
                s += "\n\tparticles: ";
                for (int i=0; i<particleIds.length; i++)
                {
                        s += particleIds[i] + " ";
                }
                s += "\n\tsubObjects: ";
                for (int i=0; i<subObjectIds.length; i++)
                {
                        s += subObjectIds[i] + " ";
                }
                s += "\n\tstates: ";
                for (int i=0; i<stateIds.length; i++)
                {
                        s += stateIds[i] + " ";
                }

                return s;
        }

        public Vector3f getCentreOfMass()
        {
                return centreOfMass;
        }

        public AxisAngle4f getOrientation()
        {
                return orientation;
        }

        public void setCentreOfMass(Vector3f com)
        {
                centreOfMass = com;
        }

        public void setOrientation(AxisAngle4f orient)
        {
                orientation.x = orient.x;
                orientation.y = orient.y;
                orientation.z = orient.z;
                orientation.angle = orient.angle;
        }

        public void translateCentreOfMass(Vector3f trans)
        {
                centreOfMass.x += trans.x;
                centreOfMass.y += trans.y;
                centreOfMass.z += trans.z;
        }
}